//---------------------------------------------------------------------------

#include <vcl.h>
#include <windows.h>

#include "win_remote.h"
#include "win_main.h"
#include "win_rc.h"
#include "win_code.h"
#include "win_wizard.h"

#include "global.h"


#pragma hdrstop
//---------------------------------------------------------------------------
//   Important note about DLL memory management when your DLL uses the
//   static version of the RunTime Library:
//
//   If your DLL exports any functions that pass String objects (or structs/
//   classes containing nested Strings) as parameter or function results,
//   you will need to add the library MEMMGR.LIB to both the DLL project and
//   any other projects that use the DLL.  You will also need to use MEMMGR.LIB
//   if any other projects which use the DLL will be performing new or delete
//   operations on any non-TObject-derived classes which are exported from the
//   DLL. Adding MEMMGR.LIB to your project will change the DLL and its calling
//   EXE's to use the BORLNDMM.DLL as their memory manager.  In these cases,
//   the file BORLNDMM.DLL should be deployed along with your DLL.
//
//   To avoid using BORLNDMM.DLL, pass string information using "char *" or
//   ShortString parameters.
//
//   If your DLL uses the dynamic version of the RTL, you do not need to
//   explicitly add MEMMGR.LIB as this will be done implicitly for you
//---------------------------------------------------------------------------

#pragma argsused

#pragma comment(lib,"core.lib")
#pragma comment(lib,"std.lib")

HANDLE global::hinst = NULL;
bool global::state_run = FALSE;
String global::str_code = "";
lua_State* global::g = NULL;

LRESULT CALLBACK pictureProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam){
	if(msg == WM_PAINT){
		PAINTSTRUCT ps;
		HDC hdc;
		MAP_ATT &f = *(MAP_ATT*)frm_main->map_obj[hWnd];

		hdc = BeginPaint(hWnd, &ps);
		// TODO: ⿡ ׸ ڵ带 ߰մϴ.
		if(f["Picture"] != ""){
			frm_main->img_->Picture->LoadFromFile(f["Picture"]);

			HDC mem = CreateCompatibleDC(hdc);
			HBITMAP hb = frm_main->img_->Picture->Bitmap;
			HBITMAP hob = SelectObject(mem, hb);
			BITMAP bit;

			GetObjectA(hb, sizeof(hb), &bit);

			BitBlt(hdc, 0, 0, bit.bmWidth, bit.bmHeight, mem, 0, 0, SRCCOPY);

			SelectObject(mem, hob);
			DeleteObject(hb);
			DeleteDC(mem);
		}else{
			TextOutA(hdc, 50, 100, "̹ ", strlen("̹ "));
        }
		EndPaint(hWnd, &ps);
	}

	return DefWindowProc(hWnd, msg, wParam, lParam);
}

int regPicture(HINSTANCE hInstance){
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= pictureProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= NULL;
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= NULL;
	wcex.lpszClassName	= "PictureBox";
	wcex.hIconSm		= NULL;

	RegisterClassEx(&wcex);

	return 0;
}


lua_State* InitLua(){
	lua_State* s = lua_open();
	luaopen_base(s);
	luaopen_io(s);
	luaopen_math(s);
	luaopen_string(s);
	luaopen_table(s);

	return s;
}

void ReleaseLua(lua_State* s){
	lua_close(s);
}

int setLuaBaseFunction(){
	lua_register(global::g, "lua_msgbox", lua_msgbox);
	lua_register(global::g, "lua_exit", lua_exit);
	lua_register(global::g, "lua_sendkey", lua_sendkey);
	lua_register(global::g, "lua_controlMessage", lua_controlMessage);
	lua_register(global::g, "lua_setfocus", lua_setfocus);
	lua_register(global::g, "lua_setsel", lua_setsel);
	lua_register(global::g, "lua_seltext", lua_seltext);
	lua_register(global::g, "lua_getsel", lua_getsel);
	lua_register(global::g, "lua_sendmessage", lua_sendmessage);
	lua_register(global::g, "lua_getcheck", lua_getcheck);
	lua_register(global::g, "lua_setvalue", lua_setvalue);
	lua_register(global::g, "lua_getvalue", lua_getvalue);
	lua_register(global::g, "lua_output", lua_output);
	lua_register(global::g, "lua_getatt", lua_getatt);
	return 0;
}


DWORD __stdcall proc(void *){
	global::g = InitLua();
	setLuaBaseFunction();
	
	frm_remote = new Tfrm_remote(NULL);
	frm_main = new Tfrm_main(NULL);
	frm_rc = new Tfrm_rc(NULL);
	frm_code = new Tfrm_code(NULL);
	frm_wizard = new Tfrm_wizard(NULL);

	frm_remote->Top  = 0;
	frm_remote->Left = 0;
	frm_remote->ShowModal();
	ReleaseLua(global::g);
	return 1;
}

/*
DWORD __stdcall proc(void *){//ݵ ؾҰ.
	DWORD* p;

	SetAPIHook(GetModuleHandleA(NULL), "GDI32.dll", "CreateWindowA", (DWORD)proc, &back, p);
	SetAPIHook(GetModuleHandleA(NULL), "GDI32.dll", "CreateWindowW", (DWORD)proc, &back, p);
	SetAPIHook(GetModuleHandleA(NULL), "GDI32.dll", "CreateWindowExA", (DWORD)proc, &back, p);
	SetAPIHook(GetModuleHandleA(NULL), "GDI32.dll", "CreateWindowExW", (DWORD)proc, &back, p);

	return 1;
}
*/



int SetAPIHook(HANDLE h,string dll_name ,string fun_name, DWORD NewProc, DWORD* BackProc, DWORD* &p){

	PIMAGE_DOS_HEADER hbase = (PIMAGE_DOS_HEADER)h;

	PIMAGE_NT_HEADERS hnt = (PIMAGE_NT_HEADERS)((DWORD)hbase->e_lfanew + (DWORD)hbase);

	PIMAGE_IMPORT_DESCRIPTOR hdes = (PIMAGE_IMPORT_DESCRIPTOR)((DWORD)hbase + (DWORD)hnt->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT].VirtualAddress);


	while (hdes->Name)
	{
		if (NULL == stricmp((char*)((DWORD)h + (DWORD)hdes->Name), dll_name.c_str()))
		{

			PIMAGE_THUNK_DATA funfirst = (PIMAGE_THUNK_DATA)((DWORD)h + (DWORD)hdes->FirstThunk);
			PIMAGE_THUNK_DATA funorg = (PIMAGE_THUNK_DATA)((DWORD)h + (DWORD)hdes->OriginalFirstThunk);
			while(funfirst->u1.Function != NULL)
			{

				PIMAGE_IMPORT_BY_NAME pByName = (PIMAGE_IMPORT_BY_NAME)((DWORD)h + (DWORD)funorg->u1.AddressOfData);

				if (((DWORD)funfirst->u1.Function == (DWORD)GetProcAddress(LoadLibraryA(dll_name.c_str()),fun_name.c_str())) ||
				(stricmp((char*)pByName->Name,fun_name.c_str()) == 0)  )
				{
					MEMORY_BASIC_INFORMATION mbi;

					VirtualQuery(funfirst, &mbi, sizeof(mbi));

					if(!VirtualProtect(mbi.BaseAddress, mbi.RegionSize,PAGE_READWRITE, &mbi.Protect))
					{
						return NULL;
					}

					*BackProc = funfirst->u1.Function;
					funfirst->u1.Function = NewProc;
					p = &(funfirst->u1.Function);

					return 0;
				}

				funfirst++;
				funorg++;
			}
		}

		hdes++;
	}
	
	return 0;
}

BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fwdreason, LPVOID lpvReserved)
{
	if(fwdreason == DLL_PROCESS_ATTACH){
		global::hinst = hinstDLL;
		regPicture(GetModuleHandleA(NULL));
		CreateThread(NULL,0,proc,NULL,0,NULL);
	}else if(fwdreason == DLL_PROCESS_DETACH){

	}
	return 1;
}
//---------------------------------------------------------------------------
